/********************************************************************************
 * Copyright (c) 2023 CEA-List
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 ********************************************************************************/

#ifndef AIDGE_QUANTIZATION_QUANTIZATION_QAT_LSQ_H_
#define AIDGE_QUANTIZATION_QUANTIZATION_QAT_LSQ_H_

#include <cstddef>  // std::size_t
#include <memory>

#include "aidge/data/Tensor.hpp"
#include "aidge/graph/GraphView.hpp"

namespace Aidge {
namespace QuantLSQ {

/**
 * @brief Given a GraphView with parameters properly initialized, insert
 * the LSQ quantizer nodes, and setup the adjustment their step-sizes.
 * @param graphView The GraphView containing the network to quantize.
 * @param nbBits Number of quantization bits.
 */

void setupQuantizers(std::shared_ptr<GraphView> graphView, size_t nbBits);

}  // namespace QuantLSQ
}  // namespace Aidge

#endif /* AIDGE_QUANTIZATION_QUANTIZATION_QAT_LSQ_H_ */
 
 