/********************************************************************************
 * Copyright (c) 2023 CEA-List
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 ********************************************************************************/

 #include <pybind11/pybind11.h>
 #include <pybind11/stl.h>
 
 #include "aidge/quantization/QAT/QAT_LSQ.hpp"
 #include "aidge/graph/GraphView.hpp"
 
 namespace py = pybind11;
 
 namespace Aidge {
 
 void init_QAT_LSQ(py::module &m) {
 
     auto mQuantLSQ = m.def_submodule("lsq");
 
     mQuantLSQ.def("setup_quantizers", &QuantLSQ::setupQuantizers, py::arg("network"), py::arg("nb_bits"));
 }
 } // namespace Aidge
 